#include "stdio.h"
#include "math.h"

main()
{
	int blobs, count;
	float inner, outer, xpos, ypos, division, angle, radiusinc,
	      divangle, radius, orbits, tightness, ellipse;
	char s1[9];

	FILE *fptr;                          /*   OPEN FILE  */
	fptr = fopen("spiral.inc", "w");

	printf("Number of Blobs: ");        /*  INPUT DATA  */
	scanf("%d", &blobs);
	printf("Spiral Start Radius: ");
	scanf("%f", &inner);
	printf("Spiral Outer Radius: ");
	scanf("%f", &outer);
	printf("'Orbits' (2=Stand.): ");
	scanf("%f", &orbits);
	printf("Tightness (1=Stand): ");
	scanf("%f", &tightness);
	printf("Ellipse Factor (1=Circular): ");
	scanf("%f", &ellipse);

/*** SET UP VARIABLES USING INPUT DATA  ***/

	division=M_PI*orbits / blobs;  /* HOW BIG ANGLE BETWEEN EACH BLOB  */
	divangle=360/blobs;            /* CONVERT TO DEGREES FOR COMMENTS  */
	radiusinc=(outer-inner)/blobs; /* ADD TO RADIUS DURING EACH LOOP  */
	radius=inner;	    	       /* BEGINNER RADIUS */


/***  COMMENTS AT TOP OF "SPIRAL.INC"  ***/

fprintf(fptr,"//     Sweep: %f degrees per seg\n",divangle);
fprintf(fptr,"//  Start at: %f          Stop Radius: %f\n",inner,outer);
fprintf(fptr,"//     Orbit: %fPI Radians  Tightness: %f\n",orbits,tightness);
fprintf(fptr,"//Ellipicity: Semi-X Axis is %fTimes Semi-Y axis\n",ellipse);


/***   BEGIN LOOPING   ***/

for (count=1; count<blobs+1; count++) {

/**  INCREMENTING VARIABLES  **/
  angle=division*count;                /* SETS CURRENT ANGLE  */
  xpos=ellipse*radius*sin(angle);      /* PLOT X POS (Times ellipse factor)*/
  ypos=radius*cos(angle);              /* PLOT Y POS */
  radius=(radius+radiusinc)*tightness; /* INCREASE RADIUS (Times Tightness)*/

/**  COMPONENT OUTPUT  **/
  fprintf(fptr,"//**Blob #%d Radius=%f\n",count,radius); /*COMMENT*/
  fprintf(fptr,"component BlobStr, BlobRad, <%f,%f,0>\n",xpos,ypos);
  fprintf(fptr,"component BlobStr, BlobRad, <%f,%f,0>\n",-xpos,-ypos);
  }      /* CLOSE LOOP */
		 /* THE 3rd LINE ABOVE IS WHAT MAKES A DOUBLE SPIRAL */
		 /* REMOVE IT TO CREATE SINGLE SPIRALS           */


  fclose(fptr);  /* CLOSE FILE */

}
